<template>
  <div class="m-4">
    <b-card>
      <b-overlay :show="show" rounded="sm">
        <div slot="header">
          <strong>Cars</strong>
        </div>
        <b-form>
          <b-form-group id="vin" label="vin" label-for="vin" :state="vin">
            <b-form-input v-model="car.vin" :state="vin" trim></b-form-input>
          </b-form-group>
          <b-form-group
            id="license"
            label="license"
            label-for="license"
            :state="license"
          >
            <b-form-input
              v-model="car.license"
              :state="license"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="vehicleBrand"
            label="vehicleBrand"
            label-for="vehicleBrand"
            :state="vehicleBrand"
          >
            <b-form-input
              v-model="car.vehicleBrand"
              :state="vehicleBrand"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="vehicleModel"
            label="vehicleModel"
            label-for="vehicleModel"
            :state="vehicleModel"
          >
            <b-form-input
              v-model="car.vehicleModel"
              :state="vehicleModel"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="deviceID"
            label="deviceID"
            label-for="deviceID"
            :state="deviceID"
          >
            <b-form-input
              v-model="car.deviceID"
              :state="deviceID"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="deviceBrand"
            label="deviceBrand"
            label-for="deviceBrand"
            :state="deviceBrand"
          >
            <b-form-input
              v-model="car.deviceBrand"
              :state="deviceBrand"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="deviceModel"
            label="deviceModel"
            label-for="deviceModel"
            :state="deviceModel"
          >
            <b-form-input
              v-model="car.deviceModel"
              :state="deviceModel"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="lastMaintenanceOdo"
            label="lastMaintenanceOdo"
            label-for="lastMaintenanceOdo"
            :state="lastMaintenanceOdo"
          >
            <b-form-input
              v-model="car.lastMaintenanceOdo"
              type="number"
              :state="lastMaintenanceOdo"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group
            id="lastMaintenanceDate"
            label="lastMaintenanceDate"
            label-for="lastMaintenanceDate"
          >
            <b-input-group class="mb-3">
              <b-form-input
                id="example-input"
                v-model="car.lastMaintenanceDate"
                type="text"
                placeholder="YYYY-MM-DD"
                autocomplete="off"
              ></b-form-input>
              <b-input-group-append>
                <b-form-datepicker
                  v-model="car.lastMaintenanceDate"
                  button-only
                  right
                  locale="en-US"
                  aria-controls="example-input"
                  @context="onContext"
                ></b-form-datepicker>
              </b-input-group-append>
            </b-input-group>
          </b-form-group>
          <b-form-group id="status" label="status" label-for="status">
            <b-form-select
              v-model="car.status"
              :options="options_status"
              trim
            ></b-form-select>
          </b-form-group>
          <b-form-group
            id="currentLocation"
            label="currentLocation"
            label-for="currentLocation"
          >
            <b-row>
              <b-col cols="6">
                <b-form-input
                  v-model="car.currentLocation.lat"
                  type="number"
                  :state="lat"
                  :disabled="action == 'update'"
                  trim
                ></b-form-input>
              </b-col>
              <b-col cols="6">
                <b-form-input
                  v-model="car.currentLocation.lng"
                  type="number"
                  :state="lng"
                  :disabled="action == 'update'"
                  trim
                ></b-form-input>
              </b-col>
            </b-row>
          </b-form-group>
          <b-form-group
            id="currentOdo"
            label="currentOdo"
            label-for="currentOdo"
            :state="currentOdo"
          >
            <b-form-input
              v-model="car.currentOdo"
              type="number"
              :state="currentOdo"
              :disabled="action == 'update'"
              trim
            ></b-form-input>
          </b-form-group>
          <b-form-group id="notes" label="notes" label-for="notes">
            <b-form-input v-model="car.notes" trim></b-form-input>
          </b-form-group>
          <b-row>
            <b-col>
              <b-button
                style="float: right"
                @click="addCars()"
                variant="success"
                :disabled="!validateInput()"
                >Save</b-button
              >
            </b-col>
            <b-col>
              <b-button @click="backPage()" variant="outline-danger"
                >Cancel</b-button
              >
            </b-col>
          </b-row>
        </b-form>
      </b-overlay>
    </b-card>
  </div>
</template>

<script>
export default {
  computed: {
    vin() {
      return /^([a-zA-Z0-9]{17,})$/.test(this.car.vin);
    },
    license() {
      return /^([^]{1,20})$/.test(this.car.license);
    },
    vehicleBrand() {
      return /^([^]{1,20})$/.test(this.car.vehicleBrand);
    },
    vehicleModel() {
      return /^([^]{1,20})$/.test(this.car.vehicleModel);
    },
    deviceID() {
      return /^([^]{1,20})$/.test(this.car.deviceID);
    },
    deviceBrand() {
      return /^([^]{1,20})$/.test(this.car.deviceBrand);
    },
    deviceModel() {
      return /^([^]{1,20})$/.test(this.car.deviceModel);
    },
    lastMaintenanceOdo() {
      return /^([0-9]{1,20})$/.test(this.car.lastMaintenanceOdo);
    },
    lat() {
      return /^\s*(-|\+)?(0|[1-9]\d*)\.\d{6}\s*$/.test(
        this.car.currentLocation.lat
      );
    },
    lng() {
      return /^\s*(-|\+)?(0|[1-9]\d*)\.\d{6}\s*$/.test(
        this.car.currentLocation.lng
      );
    },
    currentOdo() {
      return /^([0-9]{1,20})$/.test(this.car.currentOdo);
    },
  },
  data() {
    return {
      car: {
        vin: "",
        license: "",
        vehicleBrand: "",
        vehicleModel: "",
        deviceID: "",
        deviceBrand: "",
        deviceModel: "",
        lastMaintenanceOdo: 0,
        lastMaintenanceDate: "",
        status: "",
        currentLocation: { lat: 0, lng: 0 },
        currentOdo: 0,
        notes: "",
      },
      options_status: [
        { value: "InUse", text: "InUse" },
        { value: "Available", text: "Available" },
        { value: "Maintenance", text: "Maintenance" },
        { value: "Inactive", text: "Inactive" },
      ],
      value: "",
      formatted: "",
      selected: "",
      show: false,
      action: ''
    };
  },
  async created() {
    console.log(this.$route.params.id);
    if (this.$route.params.id) {
      this.action = 'update'
      await this.fetchById(this.$route.params.id);
    } else {
      this.action = 'create'
    }
  },
  methods: {
    backPage() {
      this.$router.push({ name: "Car List" });
    },
    onContext(ctx) {
      this.formatted = ctx.selectedFormatted;
      this.selected = ctx.selectedYMD;
      this.car.lastMaintenanceDate = this.selected;
    },
    validateInput() {
      if (!/^([a-zA-Z0-9]{17,})$/.test(this.car.vin)) {
        return false;
      } else if (!/^([^]{1,20})$/.test(this.car.license)) {
        return false;
      } else if (!/^([^]{1,20})$/.test(this.car.vehicleBrand)) {
        return false;
      } else if (!/^([^]{1,20})$/.test(this.car.vehicleModel)) {
        return false;
      } else if (!/^([^]{1,20})$/.test(this.car.deviceID)) {
        return false;
      } else if (!/^([^]{1,20})$/.test(this.car.deviceModel)) {
        return false;
      } else if (!/^([0-9]{1,20})$/.test(this.car.lastMaintenanceOdo)) {
        return false;
      } else if (
        !/^\s*(-|\+)?(0|[1-9]\d*)\.\d{6}\s*$/.test(this.car.currentLocation.lat)
      ) {
        return false;
      } else if (
        !/^\s*(-|\+)?(0|[1-9]\d*)\.\d{6}\s*$/.test(this.car.currentLocation.lng)
      ) {
        return false;
      } else if (!/^([0-9]{1,20})$/.test(this.car.currentOdo)) {
        return false;
      }
      return true;
    },
    async fetchById(id) {
      this.show = true;
      await this.axios
        .get(
          `https://d16c9f74-b46c-415e-bb10-9d5169cc5625.mock.pstmn.io/cars/vin=${id}`
        )
        .then((response) => {
          this.car = response.data;
          this.show = false;
        })
        .catch((error) => window.alert(error));
    },
    async addCars() {
      if (this.validateInput()) {
        this.show = true;
        if (this.$route.params.id) {
          await this.axios
            .put(
              `https://d16c9f74-b46c-415e-bb10-9d5169cc5625.mock.pstmn.io/cars/vin=${this.$route.params.id}`,
              this.cars
            )
            .then((response) => {
              console.log(response);
              window.alert("update car success");
              this.show = false;
              this.backPage();
            })
            .catch((error) => window.alert(error));
        } else {
          await this.axios
            .post(
              `https://d16c9f74-b46c-415e-bb10-9d5169cc5625.mock.pstmn.io/cars`,
              this.cars
            )
            .then((response) => {
              console.log(response);
              window.alert("add car success");
              this.show = false;
              this.backPage();
            })
            .catch((error) => window.alert(error));
        }
      } else {
        window.alert("กรุณากรอกข้อมูลให้ถูกต้อง");
      }
    },
  },
};
</script>

<style lang="scss">
</style>